/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.225 Revision 1.353
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.225 2006/02/18 10:50:10 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.353 2011/01/09 02:16:53 vapier Exp $
4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
4# 14#
5# Author: Martin Schlemmer <azarah@gentoo.org> 15# Due to the nature of this eclass, some functions may have maintainers
6# 16# different from the overall eclass!
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 17
12inherit multilib portability 18inherit multilib portability
13 19
14DEPEND="!bootstrap? ( sys-devel/patch )"
15# sys-apps/shadow is needed for useradd, etc, bug #94745.
16
17DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
18 21
19# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
21# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
22# must be an integer greater than zero. 25# @USAGE: [seconds]
23# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
24epause() { 31epause() {
25 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
26 sleep ${1:-5}
27 fi
28} 33}
29 34
30# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
31# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
32# don't beep. 37# @DESCRIPTION:
33# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
34ebeep() { 42ebeep() {
35 local n 43 local n
36 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
37 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
38 echo -ne "\a" 46 echo -ne "\a"
39 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
40 echo -ne "\a" 48 echo -ne "\a"
41 sleep 1 49 sleep 1
42 done 50 done
43 fi 51 fi
44} 52}
45 53
46# This function generate linker scripts in /usr/lib for dynamic 54else
47# libs in /lib. This is to fix linking problems when you have
48# the .so in /lib, and the .a in /usr/lib. What happens is that
49# in some cases when linking dynamic, the .a in /usr/lib is used
50# instead of the .so in /lib due to gcc/libtool tweaking ld's
51# library search path. This cause many builds to fail.
52# See bug #4411 for more info.
53#
54# To use, simply call:
55#
56# gen_usr_ldscript libfoo.so
57#
58# Note that you should in general use the unversioned name of
59# the library, as ldconfig should usually update it correctly
60# to point to the latest version of the library present.
61#
62# <azarah@gentoo.org> (26 Oct 2002)
63#
64gen_usr_ldscript() {
65 local lib libdir=$(get_libdir)
66 # Just make sure it exists
67 dodir /usr/${libdir}
68 55
69 for lib in "${@}" ; do 56ebeep() {
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
71 /* GNU ld script 58}
72 Since Gentoo has critical dynamic libraries
73 in /lib, and the static versions in /usr/lib,
74 we need to have a "fake" dynamic lib in /usr/lib,
75 otherwise we run into linking problems.
76 59
77 See bug http://bugs.gentoo.org/4411 for more info. 60epause() {
78 */ 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
79 GROUP ( /${libdir}/${lib} ) 62}
80 END_LDSCRIPT 63
81 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to einfo for package managers that don't provide eqawarn and use the PM
70# implementation if available.
71if ! declare -F eqawarn >/dev/null ; then
72 eqawarn() {
73 einfo "$@"
74 }
75fi
76
77# @FUNCTION: ecvs_clean
78# @USAGE: [list of dirs]
79# @DESCRIPTION:
80# Remove CVS directories recursiveley. Useful when a source tarball contains
81# internal CVS directories. Defaults to $PWD.
82ecvs_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
85 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
86}
87
88# @FUNCTION: esvn_clean
89# @USAGE: [list of dirs]
90# @DESCRIPTION:
91# Remove .svn directories recursiveley. Useful when a source tarball contains
92# internal Subversion directories. Defaults to $PWD.
93esvn_clean() {
94 [[ -z $* ]] && set -- .
95 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
96}
97
98# @FUNCTION: eshopts_push
99# @USAGE: [options to `set` or `shopt`]
100# @DESCRIPTION:
101# Often times code will want to enable a shell option to change code behavior.
102# Since changing shell options can easily break other pieces of code (which
103# assume the default state), eshopts_push is used to (1) push the current shell
104# options onto a stack and (2) pass the specified arguments to set.
105#
106# If the first argument is '-s' or '-u', we assume you want to call `shopt`
107# rather than `set` as there are some options only available via that.
108#
109# A common example is to disable shell globbing so that special meaning/care
110# may be used with variables/arguments to custom functions. That would be:
111# @CODE
112# eshopts_push -o noglob
113# for x in ${foo} ; do
114# if ...some check... ; then
115# eshopts_pop
116# return 0
117# fi
82 done 118# done
119# eshopts_pop
120# @CODE
121eshopts_push() {
122 # have to assume __ESHOPTS_SAVE__ isn't screwed with
123 # as a `declare -a` here will reset its value
124 local i=${#__ESHOPTS_SAVE__[@]}
125 if [[ $1 == -[su] ]] ; then
126 __ESHOPTS_SAVE__[$i]=$(shopt -p)
127 [[ $# -eq 0 ]] && return 0
128 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
129 else
130 __ESHOPTS_SAVE__[$i]=$-
131 [[ $# -eq 0 ]] && return 0
132 set "$@" || die "eshopts_push: bad options to set: $*"
133 fi
83} 134}
84 135
136# @FUNCTION: eshopts_pop
137# @USAGE:
138# @DESCRIPTION:
139# Restore the shell options to the state saved with the corresponding
140# eshopts_push call. See that function for more details.
141eshopts_pop() {
142 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
143 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
144 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
145 local s=${__ESHOPTS_SAVE__[$i]}
146 unset __ESHOPTS_SAVE__[$i]
147 if [[ ${s} == "shopt -"* ]] ; then
148 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
149 else
150 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
151 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
152 fi
153}
85 154
86# Default directory where patches are located 155# @VARIABLE: EPATCH_SOURCE
156# @DESCRIPTION:
157# Default directory to search for patches.
87EPATCH_SOURCE="${WORKDIR}/patch" 158EPATCH_SOURCE="${WORKDIR}/patch"
88# Default extension for patches 159# @VARIABLE: EPATCH_SUFFIX
160# @DESCRIPTION:
161# Default extension for patches (do not prefix the period yourself).
89EPATCH_SUFFIX="patch.bz2" 162EPATCH_SUFFIX="patch.bz2"
163# @VARIABLE: EPATCH_OPTS
164# @DESCRIPTION:
90# Default options for patch 165# Default options for patch:
166# @CODE
91# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 167# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
92# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 168# --no-backup-if-mismatch - do not leave .orig files behind
169# -E - automatically remove empty files
170# @CODE
93EPATCH_OPTS="-g0 --no-backup-if-mismatch" 171EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
172# @VARIABLE: EPATCH_EXCLUDE
173# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 174# List of patches not to apply. Note this is only file names,
95# and not the full path .. 175# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 176EPATCH_EXCLUDE=""
177# @VARIABLE: EPATCH_SINGLE_MSG
178# @DESCRIPTION:
97# Change the printed message for a single patch. 179# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 180EPATCH_SINGLE_MSG=""
181# @VARIABLE: EPATCH_MULTI_MSG
182# @DESCRIPTION:
99# Change the printed message for multiple patches. 183# Change the printed message for multiple patches.
100EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 184EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
101# Force applying bulk patches even if not following the style: 185# @VARIABLE: EPATCH_FORCE
102# 186# @DESCRIPTION:
103# ??_${ARCH}_foo.${EPATCH_SUFFIX} 187# Only require patches to match EPATCH_SUFFIX rather than the extended
104# 188# arch naming style.
105EPATCH_FORCE="no" 189EPATCH_FORCE="no"
106 190
107# This function is for bulk patching, or in theory for just one 191# @FUNCTION: epatch
108# or two patches. 192# @USAGE: [patches] [dirs of patches]
193# @DESCRIPTION:
194# epatch is designed to greatly simplify the application of patches. It can
195# process patch files directly, or directories of patches. The patches may be
196# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
197# the -p option as epatch will automatically attempt -p0 to -p5 until things
198# apply successfully.
109# 199#
110# It should work with .bz2, .gz, .zip and plain text patches. 200# If you do not specify any options, then epatch will default to the directory
111# Currently all patches should be the same format. 201# specified by EPATCH_SOURCE.
112# 202#
113# You do not have to specify '-p' option to patch, as it will 203# When processing directories, epatch will apply all patches that match:
114# try with -p0 to -p5 until it succeed, or fail at -p5. 204# @CODE
115# 205# if ${EPATCH_FORCE} != "yes"
116# Above EPATCH_* variables can be used to control various defaults,
117# bug they should be left as is to ensure an ebuild can rely on
118# them for.
119#
120# Patches are applied in current directory.
121#
122# Bulk Patches should preferibly have the form of:
123#
124# ??_${ARCH}_foo.${EPATCH_SUFFIX} 206# ??_${ARCH}_foo.${EPATCH_SUFFIX}
207# else
208# *.${EPATCH_SUFFIX}
209# @CODE
210# The leading ?? are typically numbers used to force consistent patch ordering.
211# The arch field is used to apply patches only for the host architecture with
212# the special value of "all" means apply for everyone. Note that using values
213# other than "all" is highly discouraged -- you should apply patches all the
214# time and let architecture details be detected at configure/compile time.
125# 215#
126# For example: 216# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
217# for patches to apply.
127# 218#
128# 01_all_misc-fix.patch.bz2 219# Refer to the other EPATCH_xxx variables for more customization of behavior.
129# 02_sparc_another-fix.patch.bz2
130#
131# This ensures that there are a set order, and you can have ARCH
132# specific patches.
133#
134# If you however give an argument to epatch(), it will treat it as a
135# single patch that need to be applied if its a file. If on the other
136# hand its a directory, it will set EPATCH_SOURCE to this.
137#
138# <azarah@gentoo.org> (10 Nov 2002)
139#
140epatch() { 220epatch() {
141 _epatch_draw_line() { 221 _epatch_draw_line() {
142 local i=0 str_length="" str_out="" 222 # create a line of same length as input string
143 223 [[ -z $1 ]] && set "$(printf "%65s" '')"
144 # Handle calls that do not have args, or wc not being installed ... 224 echo "${1//?/=}"
145 if [[ -z $1 ]] || ! type -p wc >/dev/null ; then
146 str_length=65
147 else
148 str_length=$(echo -n "$*" | wc -m)
149 fi
150
151 while ((i++ < ${str_length})) ; do
152 str_out="${str_out}="
153 done
154 echo ${str_out}
155
156 return 0
157 } 225 }
158 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
159 local PIPE_CMD=""
160 local STDERR_TARGET="${T}/$$.out"
161 local PATCH_TARGET="${T}/$$.patch"
162 local PATCH_SUFFIX=""
163 local SINGLE_PATCH="no"
164 local x=""
165 226
166 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 227 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
167 228
168 if [ "$#" -gt 1 ] 229 # Let the rest of the code process one user arg at a time --
169 then 230 # each arg may expand into multiple patches, and each arg may
231 # need to start off with the default global EPATCH_xxx values
232 if [[ $# -gt 1 ]] ; then
170 local m="" 233 local m
171 for m in "$@" ; do 234 for m in "$@" ; do
172 epatch "${m}" 235 epatch "${m}"
173 done 236 done
174 return 0 237 return 0
175 fi 238 fi
176 239
177 if [ -n "$1" -a -f "$1" ] 240 local SINGLE_PATCH="no"
178 then 241 # no args means process ${EPATCH_SOURCE}
242 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
243
244 if [[ -f $1 ]] ; then
179 SINGLE_PATCH="yes" 245 SINGLE_PATCH="yes"
180 246 set -- "$1"
181 local EPATCH_SOURCE="$1" 247 # Use the suffix from the single patch (localize it); the code
248 # below will find the suffix for us
182 local EPATCH_SUFFIX="${1##*\.}" 249 local EPATCH_SUFFIX=$1
183 250
184 elif [ -n "$1" -a -d "$1" ] 251 elif [[ -d $1 ]] ; then
185 then 252 # Some people like to make dirs of patches w/out suffixes (vim)
186 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 253 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
187 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 254
255 else
256 # sanity check ... if it isn't a dir or file, wtf man ?
257 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
258 echo
259 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
260 eerror
261 eerror " ${EPATCH_SOURCE}"
262 eerror " ( ${EPATCH_SOURCE##*/} )"
263 echo
264 die "Cannot find \$EPATCH_SOURCE!"
265 fi
266
267 local PIPE_CMD
268 case ${EPATCH_SUFFIX##*\.} in
269 xz) PIPE_CMD="xz -dc" ;;
270 lzma) PIPE_CMD="lzma -dc" ;;
271 bz2) PIPE_CMD="bzip2 -dc" ;;
272 gz|Z|z) PIPE_CMD="gzip -dc" ;;
273 ZIP|zip) PIPE_CMD="unzip -p" ;;
274 *) ;;
275 esac
276
277 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
278
279 local x
280 for x in "$@" ; do
281 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
282 # didn't match anything, ignore continue on
283 [[ ! -f ${x} ]] && continue
284
285 local patchname=${x##*/}
286
287 # Apply single patches, or forced sets of patches, or
288 # patches with ARCH dependant names.
289 # ???_arch_foo.patch
290 # Else, skip this input altogether
291 local a=${patchname#*_} # strip the ???_
292 a=${a%%_*} # strip the _foo.patch
293 if ! [[ ${SINGLE_PATCH} == "yes" || \
294 ${EPATCH_FORCE} == "yes" || \
295 ${a} == all || \
296 ${a} == ${ARCH} ]]
188 then 297 then
189 local EPATCH_SOURCE="$1/*" 298 continue
299 fi
300
301 # Let people filter things dynamically
302 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
303 # let people use globs in the exclude
304 eshopts_push -o noglob
305
306 local ex
307 for ex in ${EPATCH_EXCLUDE} ; do
308 if [[ ${patchname} == ${ex} ]] ; then
309 eshopts_pop
310 continue 2
311 fi
312 done
313
314 eshopts_pop
315 fi
316
317 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
318 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
319 einfo "${EPATCH_SINGLE_MSG}"
320 else
321 einfo "Applying ${patchname} ..."
322 fi
190 else 323 else
191 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 324 einfo " ${patchname} ..."
192 fi 325 fi
193 else 326
194 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 327 # most of the time, there will only be one run per unique name,
195 then 328 # but if there are more, make sure we get unique log filenames
196 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 329 local STDERR_TARGET="${T}/${patchname}.out"
197 then 330 if [[ -e ${STDERR_TARGET} ]] ; then
198 EPATCH_SOURCE="$1" 331 STDERR_TARGET="${T}/${patchname}-$$.out"
332 fi
333
334 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
335
336 # Decompress the patch if need be
337 local count=0
338 local PATCH_TARGET
339 if [[ -n ${PIPE_CMD} ]] ; then
340 PATCH_TARGET="${T}/$$.patch"
341 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
342
343 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
344 echo
345 eerror "Could not extract patch!"
346 #die "Could not extract patch!"
347 count=5
348 break
199 fi 349 fi
350 else
351 PATCH_TARGET=${x}
352 fi
200 353
354 # Check for absolute paths in patches. If sandbox is disabled,
355 # people could (accidently) patch files in the root filesystem.
356 # Or trigger other unpleasantries #237667. So disallow -p0 on
357 # such patches.
358 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
359 if [[ -n ${abs_paths} ]] ; then
360 count=1
361 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
362 fi
363 # Similar reason, but with relative paths.
364 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
365 if [[ -n ${rel_paths} ]] ; then
366 eqawarn "QA Notice: Your patch uses relative paths '../'."
367 eqawarn " In the future this will cause a failure."
368 eqawarn "${rel_paths}"
369 fi
370
371 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
372 while [[ ${count} -lt 5 ]] ; do
373 # Generate some useful debug info ...
374 (
375 _epatch_draw_line "***** ${patchname} *****"
201 echo 376 echo
202 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 377 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
378 echo
379 _epatch_draw_line "***** ${patchname} *****"
380 ) >> "${STDERR_TARGET}"
381
382 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
383 (
384 _epatch_draw_line "***** ${patchname} *****"
385 echo
386 echo "ACTUALLY APPLYING ${patchname} ..."
387 echo
388 _epatch_draw_line "***** ${patchname} *****"
389 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
390 ) >> "${STDERR_TARGET}"
391
392 if [ $? -ne 0 ] ; then
393 echo
394 eerror "A dry-run of patch command succeeded, but actually"
395 eerror "applying the patch failed!"
396 #die "Real world sux compared to the dreamworld!"
397 count=5
398 fi
399 break
400 fi
401
402 : $(( count++ ))
403 done
404
405 # if we had to decompress the patch, delete the temp one
406 if [[ -n ${PIPE_CMD} ]] ; then
407 rm -f "${PATCH_TARGET}"
408 fi
409
410 if [[ ${count} -ge 5 ]] ; then
411 echo
412 eerror "Failed Patch: ${patchname} !"
413 eerror " ( ${PATCH_TARGET} )"
203 eerror 414 eerror
204 eerror " ${EPATCH_SOURCE}" 415 eerror "Include in your bugreport the contents of:"
205 eerror " ( ${EPATCH_SOURCE##*/} )" 416 eerror
417 eerror " ${STDERR_TARGET}"
206 echo 418 echo
207 die "Cannot find \$EPATCH_SOURCE!"
208 fi
209
210 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
211 fi
212
213 case ${EPATCH_SUFFIX##*\.} in
214 bz2)
215 PIPE_CMD="bzip2 -dc"
216 PATCH_SUFFIX="bz2"
217 ;;
218 gz|Z|z)
219 PIPE_CMD="gzip -dc"
220 PATCH_SUFFIX="gz"
221 ;;
222 ZIP|zip)
223 PIPE_CMD="unzip -p"
224 PATCH_SUFFIX="zip"
225 ;;
226 *)
227 PIPE_CMD="cat"
228 PATCH_SUFFIX="patch"
229 ;;
230 esac
231
232 if [ "${SINGLE_PATCH}" = "no" ]
233 then
234 einfo "${EPATCH_MULTI_MSG}"
235 fi
236 for x in ${EPATCH_SOURCE}
237 do
238 # New ARCH dependant patch naming scheme ...
239 #
240 # ???_arch_foo.patch
241 #
242 if [ -f ${x} ] && \
243 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
244 [ "${EPATCH_FORCE}" = "yes" ])
245 then
246 local count=0
247 local popts="${EPATCH_OPTS}"
248 local patchname=${x##*/}
249
250 if [ -n "${EPATCH_EXCLUDE}" ]
251 then
252 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
253 then
254 continue
255 fi
256 fi
257
258 if [ "${SINGLE_PATCH}" = "yes" ]
259 then
260 if [ -n "${EPATCH_SINGLE_MSG}" ]
261 then
262 einfo "${EPATCH_SINGLE_MSG}"
263 else
264 einfo "Applying ${patchname} ..."
265 fi
266 else
267 einfo " ${patchname} ..."
268 fi
269
270 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
271 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
272
273 # Allow for prefix to differ ... im lazy, so shoot me :/
274 while [ "${count}" -lt 5 ]
275 do
276 # Generate some useful debug info ...
277 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
279
280 if [ "${PATCH_SUFFIX}" != "patch" ]
281 then
282 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284 else
285 PATCH_TARGET="${x}"
286 fi
287
288 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
289 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
290
291 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
292 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
293
294 if [ "${PATCH_SUFFIX}" != "patch" ]
295 then
296 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
297 then
298 echo
299 eerror "Could not extract patch!"
300 #die "Could not extract patch!"
301 count=5
302 break
303 fi
304 fi
305
306 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
307 then
308 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
309 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
310 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
311 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
312 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
313
314 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
315 _epatch_assert
316
317 if [ "$?" -ne 0 ]
318 then
319 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
320 echo
321 eerror "A dry-run of patch command succeeded, but actually"
322 eerror "applying the patch failed!"
323 #die "Real world sux compared to the dreamworld!"
324 count=5
325 fi
326
327 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
328
329 break
330 fi
331
332 count=$((count + 1))
333 done
334
335 if [ "${PATCH_SUFFIX}" != "patch" ]
336 then
337 rm -f ${PATCH_TARGET}
338 fi
339
340 if [ "${count}" -eq 5 ]
341 then
342 echo
343 eerror "Failed Patch: ${patchname} !"
344 eerror " ( ${PATCH_TARGET} )"
345 eerror
346 eerror "Include in your bugreport the contents of:"
347 eerror
348 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
349 echo
350 die "Failed Patch: ${patchname}!" 419 die "Failed Patch: ${patchname}!"
351 fi 420 fi
352 421
353 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 422 # if everything worked, delete the patch log
354 423 rm -f "${STDERR_TARGET}"
355 eend 0 424 eend 0
356 fi
357 done 425 done
358 if [ "${SINGLE_PATCH}" = "no" ] 426
359 then 427 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
360 einfo "Done with patching" 428 : # everything worked
429}
430epatch_user() {
431 [[ $# -ne 0 ]] && die "epatch_user takes no options"
432
433 # don't clobber any EPATCH vars that the parent might want
434 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
435 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
436 EPATCH_SOURCE=${base}/${CTARGET}/${check}
437 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
438 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
439 if [[ -d ${EPATCH_SOURCE} ]] ; then
440 EPATCH_SOURCE=${EPATCH_SOURCE} \
441 EPATCH_SUFFIX="patch" \
442 EPATCH_FORCE="yes" \
443 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
444 epatch
445 return 0
361 fi 446 fi
447 done
448 return 1
362} 449}
363 450
451# @FUNCTION: emktemp
452# @USAGE: [temp dir]
453# @DESCRIPTION:
364# Cheap replacement for when debianutils (and thus mktemp) 454# Cheap replacement for when debianutils (and thus mktemp)
365# does not exist on the users system 455# does not exist on the users system.
366# vapier@gentoo.org
367#
368# Takes just 1 optional parameter (the directory to create tmpfile in)
369emktemp() { 456emktemp() {
370 local exe="touch" 457 local exe="touch"
371 [[ $1 == -d ]] && exe="mkdir" && shift 458 [[ $1 == -d ]] && exe="mkdir" && shift
372 local topdir=$1 459 local topdir=$1
373 460
375 [[ -z ${T} ]] \ 462 [[ -z ${T} ]] \
376 && topdir="/tmp" \ 463 && topdir="/tmp" \
377 || topdir=${T} 464 || topdir=${T}
378 fi 465 fi
379 466
380 if [[ -z $(type -p mktemp) ]] ; then 467 if ! type -P mktemp > /dev/null ; then
468 # system lacks `mktemp` so we have to fake it
381 local tmp=/ 469 local tmp=/
382 while [[ -e ${tmp} ]] ; do 470 while [[ -e ${tmp} ]] ; do
383 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 471 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
384 done 472 done
385 ${exe} "${tmp}" || ${exe} -p "${tmp}" 473 ${exe} "${tmp}" || ${exe} -p "${tmp}"
386 echo "${tmp}" 474 echo "${tmp}"
387 else 475 else
476 # the args here will give slightly wierd names on BSD,
477 # but should produce a usable file on all userlands
388 if [[ ${exe} == "touch" ]] ; then 478 if [[ ${exe} == "touch" ]] ; then
389 [[ ${USERLAND} == "GNU" ]] \
390 && mktemp -p "${topdir}" \
391 || TMPDIR="${topdir}" mktemp -t tmp 479 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
392 else 480 else
393 [[ ${USERLAND} == "GNU" ]] \
394 && mktemp -d "${topdir}" \
395 || TMPDIR="${topdir}" mktemp -dt tmp 481 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
396 fi
397 fi 482 fi
483 fi
398} 484}
399 485
486# @FUNCTION: egetent
487# @USAGE: <database> <key>
488# @MAINTAINER:
489# base-system@gentoo.org (Linux)
490# Joe Jezak <josejx@gmail.com> (OS X)
491# usata@gentoo.org (OS X)
492# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
493# @DESCRIPTION:
400# Small wrapper for getent (Linux), nidump (Mac OS X), 494# Small wrapper for getent (Linux),
495# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
401# and pw (FreeBSD) used in enewuser()/enewgroup() 496# and pw (FreeBSD) used in enewuser()/enewgroup()
402# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
403# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
404#
405# egetent(database, key)
406egetent() { 497egetent() {
407 case ${CHOST} in 498 case ${CHOST} in
408 *-darwin*) 499 *-darwin[678])
409 case "$2" in 500 case "$2" in
410 *[!0-9]*) # Non numeric 501 *[!0-9]*) # Non numeric
411 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 502 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
412 ;; 503 ;;
413 *) # Numeric 504 *) # Numeric
414 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 505 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
506 ;;
507 esac
508 ;;
509 *-darwin*)
510 local mytype=$1
511 [[ "passwd" == $mytype ]] && mytype="Users"
512 [[ "group" == $mytype ]] && mytype="Groups"
513 case "$2" in
514 *[!0-9]*) # Non numeric
515 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
516 ;;
517 *) # Numeric
518 local mykey="UniqueID"
519 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
520 dscl . -search /$mytype $mykey $2 2>/dev/null
415 ;; 521 ;;
416 esac 522 esac
417 ;; 523 ;;
418 *-freebsd*|*-dragonfly*) 524 *-freebsd*|*-dragonfly*)
419 local opts action="user" 525 local opts action="user"
434 getent "$1" "$2" 540 getent "$1" "$2"
435 ;; 541 ;;
436 esac 542 esac
437} 543}
438 544
439# Simplify/standardize adding users to the system 545# @FUNCTION: enewuser
440# vapier@gentoo.org 546# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
441# 547# @DESCRIPTION:
442# enewuser(username, uid, shell, homedir, groups, extra options) 548# Same as enewgroup, you are not required to understand how to properly add
443# 549# a user to the system. The only required parameter is the username.
444# Default values if you do not specify any: 550# Default uid is (pass -1 for this) next available, default shell is
445# username: REQUIRED ! 551# /bin/false, default homedir is /dev/null, there are no default groups,
446# uid: next available (see useradd(8)) 552# and default params sets the comment as 'added by portage for ${PN}'.
447# note: pass -1 to get default behavior
448# shell: /bin/false
449# homedir: /dev/null
450# groups: none
451# extra: comment of 'added by portage for ${PN}'
452enewuser() { 553enewuser() {
554 case ${EBUILD_PHASE} in
555 unpack|compile|test|install)
556 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
557 eerror "Package fails at QA and at life. Please file a bug."
558 die "Bad package! enewuser is only for use in pkg_* functions!"
559 esac
560
453 # get the username 561 # get the username
454 local euser=$1; shift 562 local euser=$1; shift
455 if [[ -z ${euser} ]] ; then 563 if [[ -z ${euser} ]] ; then
456 eerror "No username specified !" 564 eerror "No username specified !"
457 die "Cannot call enewuser without a username" 565 die "Cannot call enewuser without a username"
458 fi 566 fi
459 567
460 # lets see if the username already exists 568 # lets see if the username already exists
461 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then 569 if [[ -n $(egetent passwd "${euser}") ]] ; then
462 return 0 570 return 0
463 fi 571 fi
464 einfo "Adding user '${euser}' to your system ..." 572 einfo "Adding user '${euser}' to your system ..."
465 573
466 # options to pass to useradd 574 # options to pass to useradd
467 local opts= 575 local opts=
468 576
469 # handle uid 577 # handle uid
470 local euid=$1; shift 578 local euid=$1; shift
471 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then 579 if [[ -n ${euid} && ${euid} != -1 ]] ; then
472 if [[ ${euid} -gt 0 ]] ; then 580 if [[ ${euid} -gt 0 ]] ; then
473 if [[ ! -z $(egetent passwd ${euid}) ]] ; then 581 if [[ -n $(egetent passwd ${euid}) ]] ; then
474 euid="next" 582 euid="next"
475 fi 583 fi
476 else 584 else
477 eerror "Userid given but is not greater than 0 !" 585 eerror "Userid given but is not greater than 0 !"
478 die "${euid} is not a valid UID" 586 die "${euid} is not a valid UID"
479 fi 587 fi
480 else 588 else
481 euid="next" 589 euid="next"
482 fi 590 fi
483 if [[ ${euid} == "next" ]] ; then 591 if [[ ${euid} == "next" ]] ; then
484 for euid in $(seq 101 999) ; do 592 for ((euid = 101; euid <= 999; euid++)); do
485 [[ -z $(egetent passwd ${euid}) ]] && break 593 [[ -z $(egetent passwd ${euid}) ]] && break
486 done 594 done
487 fi 595 fi
488 opts="${opts} -u ${euid}" 596 opts="${opts} -u ${euid}"
489 einfo " - Userid: ${euid}" 597 einfo " - Userid: ${euid}"
503 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do 611 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
504 [[ -x ${ROOT}${shell} ]] && break 612 [[ -x ${ROOT}${shell} ]] && break
505 done 613 done
506 614
507 if [[ ${shell} == "/dev/null" ]] ; then 615 if [[ ${shell} == "/dev/null" ]] ; then
508 eerror "Unable to identify the shell to use" 616 eerror "Unable to identify the shell to use, proceeding with userland default."
509 die "Unable to identify the shell to use" 617 case ${USERLAND} in
618 GNU) shell="/bin/false" ;;
619 BSD) shell="/sbin/nologin" ;;
620 Darwin) shell="/usr/sbin/nologin" ;;
621 *) die "Unable to identify the default shell for userland ${USERLAND}"
622 esac
510 fi 623 fi
511 624
512 eshell=${shell} 625 eshell=${shell}
513 fi 626 fi
514 einfo " - Shell: ${eshell}" 627 einfo " - Shell: ${eshell}"
612 fi 725 fi
613 ;; 726 ;;
614 727
615 *) 728 *)
616 if [[ -z $@ ]] ; then 729 if [[ -z $@ ]] ; then
617 useradd ${opts} ${euser} \ 730 useradd -r ${opts} \
618 -c "added by portage for ${PN}" \ 731 -c "added by portage for ${PN}" \
732 ${euser} \
619 || die "enewuser failed" 733 || die "enewuser failed"
620 else 734 else
621 einfo " - Extra: $@" 735 einfo " - Extra: $@"
622 useradd ${opts} ${euser} "$@" \ 736 useradd -r ${opts} "$@" \
737 ${euser} \
623 || die "enewuser failed" 738 || die "enewuser failed"
624 fi 739 fi
625 ;; 740 ;;
626 esac 741 esac
627 742
633 fi 748 fi
634 749
635 export SANDBOX_ON=${oldsandbox} 750 export SANDBOX_ON=${oldsandbox}
636} 751}
637 752
638# Simplify/standardize adding groups to the system 753# @FUNCTION: enewgroup
639# vapier@gentoo.org 754# @USAGE: <group> [gid]
640# 755# @DESCRIPTION:
641# enewgroup(group, gid) 756# This function does not require you to understand how to properly add a
642# 757# group to the system. Just give it a group name to add and enewgroup will
643# Default values if you do not specify any: 758# do the rest. You may specify the gid for the group or allow the group to
644# groupname: REQUIRED ! 759# allocate the next available one.
645# gid: next available (see groupadd(8))
646# extra: none
647enewgroup() { 760enewgroup() {
761 case ${EBUILD_PHASE} in
762 unpack|compile|test|install)
763 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
764 eerror "Package fails at QA and at life. Please file a bug."
765 die "Bad package! enewgroup is only for use in pkg_* functions!"
766 esac
767
648 # get the group 768 # get the group
649 local egroup="$1"; shift 769 local egroup="$1"; shift
650 if [ -z "${egroup}" ] 770 if [ -z "${egroup}" ]
651 then 771 then
652 eerror "No group specified !" 772 eerror "No group specified !"
653 die "Cannot call enewgroup without a group" 773 die "Cannot call enewgroup without a group"
654 fi 774 fi
655 775
656 # see if group already exists 776 # see if group already exists
657 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ] 777 if [[ -n $(egetent group "${egroup}") ]]; then
658 then
659 return 0 778 return 0
660 fi 779 fi
661 einfo "Adding group '${egroup}' to your system ..." 780 einfo "Adding group '${egroup}' to your system ..."
662 781
663 # options to pass to useradd 782 # options to pass to useradd
706 fi 825 fi
707 826
708 # If we need the next available 827 # If we need the next available
709 case ${egid} in 828 case ${egid} in
710 *[!0-9]*) # Non numeric 829 *[!0-9]*) # Non numeric
711 for egid in $(seq 101 999); do 830 for ((egid = 101; egid <= 999; egid++)); do
712 [ -z "`egetent group ${egid}`" ] && break 831 [[ -z $(egetent group ${egid}) ]] && break
713 done 832 done
714 esac 833 esac
715 dscl . create /groups/${egroup} gid ${egid} 834 dscl . create /groups/${egroup} gid ${egid}
716 dscl . create /groups/${egroup} passwd '*' 835 dscl . create /groups/${egroup} passwd '*'
717 ;; 836 ;;
718 837
719 *-freebsd*|*-dragonfly*) 838 *-freebsd*|*-dragonfly*)
720 case ${egid} in 839 case ${egid} in
721 *[!0-9]*) # Non numeric 840 *[!0-9]*) # Non numeric
722 for egid in $(seq 101 999); do 841 for ((egid = 101; egid <= 999; egid++)); do
723 [ -z "`egetent group ${egid}`" ] && break 842 [[ -z $(egetent group ${egid}) ]] && break
724 done 843 done
725 esac 844 esac
726 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 845 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
727 ;; 846 ;;
728 847
729 *-netbsd*) 848 *-netbsd*)
730 case ${egid} in 849 case ${egid} in
731 *[!0-9]*) # Non numeric 850 *[!0-9]*) # Non numeric
732 for egid in $(seq 101 999); do 851 for ((egid = 101; egid <= 999; egid++)); do
733 [ -z "`egetent group ${egid}`" ] && break 852 [[ -z $(egetent group ${egid}) ]] && break
734 done 853 done
735 esac 854 esac
736 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 855 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
737 ;; 856 ;;
738 857
739 *) 858 *)
859 # We specify -r so that we get a GID in the system range from login.defs
740 groupadd ${opts} ${egroup} || die "enewgroup failed" 860 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
741 ;; 861 ;;
742 esac 862 esac
743 export SANDBOX_ON="${oldsandbox}" 863 export SANDBOX_ON="${oldsandbox}"
744} 864}
745 865
746# Simple script to replace 'dos2unix' binaries 866# @FUNCTION: edos2unix
747# vapier@gentoo.org 867# @USAGE: <file> [more files ...]
748# 868# @DESCRIPTION:
749# edos2unix(file, <more files> ...) 869# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
870# to remove all of these text utilities from DEPEND variables because this
871# is a script based solution. Just give it a list of files to convert and
872# they will all be changed from the DOS CRLF format to the UNIX LF format.
750edos2unix() { 873edos2unix() {
751 for f in "$@" 874 echo "$@" | xargs sed -i 's/\r$//'
752 do
753 cp "${f}" ${T}/edos2unix
754 sed 's/\r$//' ${T}/edos2unix > "${f}"
755 done
756} 875}
757
758
759##############################################################
760# START: Handle .desktop files and menu entries #
761# maybe this should be separated into a new eclass some time #
762# lanius@gentoo.org #
763##############################################################
764 876
765# Make a desktop file ! 877# Make a desktop file !
766# Great for making those icons in kde/gnome startmenu ! 878# Great for making those icons in kde/gnome startmenu !
767# Amaze your friends ! Get the women ! Join today ! 879# Amaze your friends ! Get the women ! Join today !
768# 880#
769# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 881# make_desktop_entry(<command>, [name], [icon], [type], [fields])
770# 882#
771# binary: what binary does the app run with ? 883# binary: what command does the app run with ?
772# name: the name that will show up in the menu 884# name: the name that will show up in the menu
773# icon: give your little like a pretty little icon ... 885# icon: give your little like a pretty little icon ...
774# this can be relative (to /usr/share/pixmaps) or 886# this can be relative (to /usr/share/pixmaps) or
775# a full path to an icon 887# a full path to an icon
776# type: what kind of application is this ? for categories: 888# type: what kind of application is this ? for categories:
777# http://www.freedesktop.org/Standards/desktop-entry-spec 889# http://standards.freedesktop.org/menu-spec/latest/apa.html
778# path: if your app needs to startup in a specific dir 890# fields: extra fields to append to the desktop file; a printf string
779make_desktop_entry() { 891make_desktop_entry() {
780 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 892 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
781 893
782 local exec=${1} 894 local exec=${1}
783 local name=${2:-${PN}} 895 local name=${2:-${PN}}
784 local icon=${3:-${PN}.png} 896 local icon=${3:-${PN}}
785 local type=${4} 897 local type=${4}
786 local path=${5} 898 local fields=${5}
787 899
788 if [[ -z ${type} ]] ; then 900 if [[ -z ${type} ]] ; then
789 local catmaj=${CATEGORY%%-*} 901 local catmaj=${CATEGORY%%-*}
790 local catmin=${CATEGORY##*-} 902 local catmin=${CATEGORY##*-}
791 case ${catmaj} in 903 case ${catmaj} in
792 app) 904 app)
793 case ${catmin} in 905 case ${catmin} in
906 accessibility) type=Accessibility;;
794 admin) type=System;; 907 admin) type=System;;
908 antivirus) type=System;;
909 arch) type=Archiving;;
910 backup) type=Archiving;;
795 cdr) type=DiscBurning;; 911 cdr) type=DiscBurning;;
796 dicts) type=Dictionary;; 912 dicts) type=Dictionary;;
913 doc) type=Documentation;;
797 editors) type=TextEditor;; 914 editors) type=TextEditor;;
798 emacs) type=TextEditor;; 915 emacs) type=TextEditor;;
799 emulation) type=Emulator;; 916 emulation) type=Emulator;;
800 laptop) type=HardwareSettings;; 917 laptop) type=HardwareSettings;;
801 office) type=Office;; 918 office) type=Office;;
919 pda) type=PDA;;
802 vim) type=TextEditor;; 920 vim) type=TextEditor;;
803 xemacs) type=TextEditor;; 921 xemacs) type=TextEditor;;
804 *) type=;;
805 esac 922 esac
806 ;; 923 ;;
807 924
808 dev) 925 dev)
809 type="Development" 926 type="Development"
810 ;; 927 ;;
811 928
812 games) 929 games)
813 case ${catmin} in 930 case ${catmin} in
814 action) type=ActionGame;; 931 action|fps) type=ActionGame;;
815 arcade) type=ArcadeGame;; 932 arcade) type=ArcadeGame;;
816 board) type=BoardGame;; 933 board) type=BoardGame;;
817 kid) type=KidsGame;;
818 emulation) type=Emulator;; 934 emulation) type=Emulator;;
935 kids) type=KidsGame;;
819 puzzle) type=LogicGame;; 936 puzzle) type=LogicGame;;
937 roguelike) type=RolePlaying;;
820 rpg) type=RolePlaying;; 938 rpg) type=RolePlaying;;
821 roguelike) type=RolePlaying;;
822 simulation) type=Simulation;; 939 simulation) type=Simulation;;
823 sports) type=SportsGame;; 940 sports) type=SportsGame;;
824 strategy) type=StrategyGame;; 941 strategy) type=StrategyGame;;
825 *) type=;;
826 esac 942 esac
827 type="Game;${type}" 943 type="Game;${type}"
828 ;; 944 ;;
829 945
946 gnome)
947 type="Gnome;GTK"
948 ;;
949
950 kde)
951 type="KDE;Qt"
952 ;;
953
830 mail) 954 mail)
831 type="Network;Email" 955 type="Network;Email"
832 ;; 956 ;;
833 957
834 media) 958 media)
835 case ${catmin} in 959 case ${catmin} in
960 gfx)
836 gfx) type=Graphics;; 961 type=Graphics
962 ;;
963 *)
964 case ${catmin} in
837 radio) type=Tuner;; 965 radio) type=Tuner;;
838 sound) type=Audio;; 966 sound) type=Audio;;
839 tv) type=TV;; 967 tv) type=TV;;
840 video) type=Video;; 968 video) type=Video;;
841 *) type=;; 969 esac
970 type="AudioVideo;${type}"
971 ;;
842 esac 972 esac
843 type="AudioVideo;${type}"
844 ;; 973 ;;
845 974
846 net) 975 net)
847 case ${catmin} in 976 case ${catmin} in
848 dialup) type=Dialup;; 977 dialup) type=Dialup;;
851 irc) type=IRCClient;; 980 irc) type=IRCClient;;
852 mail) type=Email;; 981 mail) type=Email;;
853 news) type=News;; 982 news) type=News;;
854 nntp) type=News;; 983 nntp) type=News;;
855 p2p) type=FileTransfer;; 984 p2p) type=FileTransfer;;
856 *) type=;; 985 voip) type=Telephony;;
857 esac 986 esac
858 type="Network;${type}" 987 type="Network;${type}"
859 ;; 988 ;;
860 989
861 sci) 990 sci)
862 case ${catmin} in 991 case ${catmin} in
863 astro*) type=Astronomy;; 992 astro*) type=Astronomy;;
864 bio*) type=Biology;; 993 bio*) type=Biology;;
865 calc*) type=Calculator;; 994 calc*) type=Calculator;;
866 chem*) type=Chemistry;; 995 chem*) type=Chemistry;;
996 elec*) type=Electronics;;
867 geo*) type=Geology;; 997 geo*) type=Geology;;
868 math*) type=Math;; 998 math*) type=Math;;
869 *) type=;; 999 physics) type=Physics;;
1000 visual*) type=DataVisualization;;
870 esac 1001 esac
871 type="Science;${type}" 1002 type="Education;Science;${type}"
1003 ;;
1004
1005 sys)
1006 type="System"
872 ;; 1007 ;;
873 1008
874 www) 1009 www)
875 case ${catmin} in 1010 case ${catmin} in
876 client) type=WebBrowser;; 1011 client) type=WebBrowser;;
877 *) type=;;
878 esac 1012 esac
879 type="Network" 1013 type="Network;${type}"
880 ;; 1014 ;;
881 1015
882 *) 1016 *)
883 type= 1017 type=
884 ;; 1018 ;;
887 if [ "${SLOT}" == "0" ] ; then 1021 if [ "${SLOT}" == "0" ] ; then
888 local desktop_name="${PN}" 1022 local desktop_name="${PN}"
889 else 1023 else
890 local desktop_name="${PN}-${SLOT}" 1024 local desktop_name="${PN}-${SLOT}"
891 fi 1025 fi
1026 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
892 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 1027 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
893 1028
1029 # Don't append another ";" when a valid category value is provided.
1030 type=${type%;}${type:+;}
1031
1032 eshopts_push -s extglob
1033 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1034 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1035 ewarn "allowed in .desktop files if the value is not an absolute path."
1036 icon=${icon%.@(xpm|png|svg)}
1037 fi
1038 eshopts_pop
1039
1040 cat <<-EOF > "${desktop}"
894echo "[Desktop Entry] 1041 [Desktop Entry]
895Encoding=UTF-8
896Version=0.9.2
897Name=${name} 1042 Name=${name}
898Type=Application 1043 Type=Application
899Comment=${DESCRIPTION} 1044 Comment=${DESCRIPTION}
900Exec=${exec} 1045 Exec=${exec}
901Path=${path} 1046 TryExec=${exec%% *}
902Icon=${icon} 1047 Icon=${icon}
903Categories=Application;${type};" > "${desktop}" 1048 Categories=${type}
1049 EOF
1050
1051 if [[ ${fields:-=} != *=* ]] ; then
1052 # 5th arg used to be value to Path=
1053 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1054 fields="Path=${fields}"
1055 fi
1056 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
904 1057
905 ( 1058 (
906 # wrap the env here so that the 'insinto' call 1059 # wrap the env here so that the 'insinto' call
907 # doesn't corrupt the env of the caller 1060 # doesn't corrupt the env of the caller
908 insinto /usr/share/applications 1061 insinto /usr/share/applications
909 doins "${desktop}" 1062 doins "${desktop}"
910 ) 1063 ) || die "installing desktop file failed"
911} 1064}
912 1065
913# Make a GDM/KDM Session file 1066# @FUNCTION: validate_desktop_entries
914# 1067# @USAGE: [directories]
915# make_desktop_entry(<title>, <command>) 1068# @MAINTAINER:
916# title: File to execute to start the Window Manager 1069# Carsten Lohrke <carlo@gentoo.org>
917# command: Name of the Window Manager 1070# @DESCRIPTION:
1071# Validate desktop entries using desktop-file-utils
1072validate_desktop_entries() {
1073 if [[ -x /usr/bin/desktop-file-validate ]] ; then
1074 einfo "Checking desktop entry validity"
1075 local directories=""
1076 for d in /usr/share/applications $@ ; do
1077 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
1078 done
1079 if [[ -n ${directories} ]] ; then
1080 for FILE in $(find ${directories} -name "*\.desktop" \
1081 -not -path '*.hidden*' | sort -u 2>/dev/null)
1082 do
1083 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1084 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1085 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
1086 done
1087 fi
1088 echo ""
1089 else
1090 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1091 fi
1092}
918 1093
1094# @FUNCTION: make_session_desktop
1095# @USAGE: <title> <command> [command args...]
1096# @DESCRIPTION:
1097# Make a GDM/KDM Session file. The title is the file to execute to start the
1098# Window Manager. The command is the name of the Window Manager.
1099#
1100# You can set the name of the file via the ${wm} variable.
919make_session_desktop() { 1101make_session_desktop() {
920 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1102 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
921 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1103 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
922 1104
923 local title=$1 1105 local title=$1
924 local command=$2 1106 local command=$2
925 local desktop=${T}/${wm}.desktop 1107 local desktop=${T}/${wm:-${PN}}.desktop
1108 shift 2
926 1109
1110 cat <<-EOF > "${desktop}"
927echo "[Desktop Entry] 1111 [Desktop Entry]
928Encoding=UTF-8
929Name=${title} 1112 Name=${title}
930Comment=This session logs you into ${title} 1113 Comment=This session logs you into ${title}
931Exec=${command} 1114 Exec=${command} $*
932TryExec=${command} 1115 TryExec=${command}
933Type=Application" > "${desktop}" 1116 Type=XSession
1117 EOF
934 1118
1119 (
1120 # wrap the env here so that the 'insinto' call
1121 # doesn't corrupt the env of the caller
935 insinto /usr/share/xsessions 1122 insinto /usr/share/xsessions
936 doins "${desktop}" 1123 doins "${desktop}"
1124 )
937} 1125}
938 1126
1127# @FUNCTION: domenu
1128# @USAGE: <menus>
1129# @DESCRIPTION:
1130# Install the list of .desktop menu files into the appropriate directory
1131# (/usr/share/applications).
939domenu() { 1132domenu() {
1133 (
1134 # wrap the env here so that the 'insinto' call
1135 # doesn't corrupt the env of the caller
940 local i j 1136 local i j ret=0
941 insinto /usr/share/applications 1137 insinto /usr/share/applications
942 for i in "$@" ; do 1138 for i in "$@" ; do
943 if [[ -f ${i} ]] ; then 1139 if [[ -f ${i} ]] ; then
944 doins "${i}" 1140 doins "${i}"
1141 ((ret+=$?))
945 elif [[ -d ${i} ]] ; then 1142 elif [[ -d ${i} ]] ; then
946 for j in "${i}"/*.desktop ; do 1143 for j in "${i}"/*.desktop ; do
947 doins "${j}" 1144 doins "${j}"
1145 ((ret+=$?))
948 done 1146 done
1147 else
1148 ((++ret))
949 fi 1149 fi
950 done 1150 done
1151 exit ${ret}
1152 )
951} 1153}
1154
1155# @FUNCTION: newmenu
1156# @USAGE: <menu> <newname>
1157# @DESCRIPTION:
1158# Like all other new* functions, install the specified menu as newname.
952newmenu() { 1159newmenu() {
1160 (
1161 # wrap the env here so that the 'insinto' call
1162 # doesn't corrupt the env of the caller
953 insinto /usr/share/applications 1163 insinto /usr/share/applications
954 newins "$1" "$2" 1164 newins "$@"
1165 )
955} 1166}
956 1167
1168# @FUNCTION: doicon
1169# @USAGE: <list of icons>
1170# @DESCRIPTION:
1171# Install the list of icons into the icon directory (/usr/share/pixmaps).
1172# This is useful in conjunction with creating desktop/menu files.
957doicon() { 1173doicon() {
1174 (
1175 # wrap the env here so that the 'insinto' call
1176 # doesn't corrupt the env of the caller
958 local i j 1177 local i j ret
959 insinto /usr/share/pixmaps 1178 insinto /usr/share/pixmaps
960 for i in "$@" ; do 1179 for i in "$@" ; do
961 if [[ -f ${i} ]] ; then 1180 if [[ -f ${i} ]] ; then
962 doins "${i}" 1181 doins "${i}"
1182 ((ret+=$?))
963 elif [[ -d ${i} ]] ; then 1183 elif [[ -d ${i} ]] ; then
964 for j in "${i}"/*.png ; do 1184 for j in "${i}"/*.png ; do
965 doins "${j}" 1185 doins "${j}"
1186 ((ret+=$?))
966 done 1187 done
1188 else
1189 ((++ret))
967 fi 1190 fi
968 done 1191 done
1192 exit ${ret}
1193 )
969} 1194}
1195
1196# @FUNCTION: newicon
1197# @USAGE: <icon> <newname>
1198# @DESCRIPTION:
1199# Like all other new* functions, install the specified icon as newname.
970newicon() { 1200newicon() {
1201 (
1202 # wrap the env here so that the 'insinto' call
1203 # doesn't corrupt the env of the caller
971 insinto /usr/share/pixmaps 1204 insinto /usr/share/pixmaps
972 newins "$1" "$2" 1205 newins "$@"
1206 )
973} 1207}
974
975##############################################################
976# END: Handle .desktop files and menu entries #
977##############################################################
978
979 1208
980# for internal use only (unpack_pdv and unpack_makeself) 1209# for internal use only (unpack_pdv and unpack_makeself)
981find_unpackable_file() { 1210find_unpackable_file() {
982 local src=$1 1211 local src=$1
983 if [[ -z ${src} ]] ; then 1212 if [[ -z ${src} ]] ; then
993 fi 1222 fi
994 [[ ! -e ${src} ]] && return 1 1223 [[ ! -e ${src} ]] && return 1
995 echo "${src}" 1224 echo "${src}"
996} 1225}
997 1226
1227# @FUNCTION: unpack_pdv
1228# @USAGE: <file to unpack> <size of off_t>
1229# @DESCRIPTION:
998# Unpack those pesky pdv generated files ... 1230# Unpack those pesky pdv generated files ...
999# They're self-unpacking programs with the binary package stuffed in 1231# They're self-unpacking programs with the binary package stuffed in
1000# the middle of the archive. Valve seems to use it a lot ... too bad 1232# the middle of the archive. Valve seems to use it a lot ... too bad
1001# it seems to like to segfault a lot :(. So lets take it apart ourselves. 1233# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1002# 1234#
1003# Usage: unpack_pdv [file to unpack] [size of off_t]
1004# - you have to specify the off_t size ... i have no idea how to extract that 1235# You have to specify the off_t size ... I have no idea how to extract that
1005# information out of the binary executable myself. basically you pass in 1236# information out of the binary executable myself. Basically you pass in
1006# the size of the off_t type (in bytes) on the machine that built the pdv 1237# the size of the off_t type (in bytes) on the machine that built the pdv
1238# archive.
1239#
1007# archive. one way to determine this is by running the following commands: 1240# One way to determine this is by running the following commands:
1241#
1242# @CODE
1008# strings <pdv archive> | grep lseek 1243# strings <pdv archive> | grep lseek
1009# strace -elseek <pdv archive> 1244# strace -elseek <pdv archive>
1245# @CODE
1246#
1010# basically look for the first lseek command (we do the strings/grep because 1247# Basically look for the first lseek command (we do the strings/grep because
1011# sometimes the function call is _llseek or something) and steal the 2nd 1248# sometimes the function call is _llseek or something) and steal the 2nd
1012# parameter. here is an example: 1249# parameter. Here is an example:
1250#
1251# @CODE
1013# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 1252# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1014# lseek 1253# lseek
1015# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1254# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1016# lseek(3, -4, SEEK_END) = 2981250 1255# lseek(3, -4, SEEK_END) = 2981250
1256# @CODE
1257#
1017# thus we would pass in the value of '4' as the second parameter. 1258# Thus we would pass in the value of '4' as the second parameter.
1018unpack_pdv() { 1259unpack_pdv() {
1019 local src=$(find_unpackable_file $1) 1260 local src=$(find_unpackable_file "$1")
1020 local sizeoff_t=$2 1261 local sizeoff_t=$2
1021 1262
1022 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1263 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1023 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1264 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1024 1265
1025 local shrtsrc=$(basename "${src}") 1266 local shrtsrc=$(basename "${src}")
1026 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1267 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1027 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1268 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1028 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1269 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1029 1270
1030 # grab metadata for debug reasons 1271 # grab metadata for debug reasons
1031 local metafile="$(emktemp)" 1272 local metafile=$(emktemp)
1032 tail -c +$((${metaskip}+1)) ${src} > ${metafile} 1273 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1033 1274
1034 # rip out the final file name from the metadata 1275 # rip out the final file name from the metadata
1035 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`" 1276 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1036 datafile="`basename ${datafile}`" 1277 datafile=$(basename "${datafile}")
1037 1278
1038 # now lets uncompress/untar the file if need be 1279 # now lets uncompress/untar the file if need be
1039 local tmpfile="$(emktemp)" 1280 local tmpfile=$(emktemp)
1040 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile} 1281 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1041 1282
1042 local iscompressed="`file -b ${tmpfile}`" 1283 local iscompressed=$(file -b "${tmpfile}")
1043 if [ "${iscompressed:0:8}" == "compress" ] ; then 1284 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1044 iscompressed=1 1285 iscompressed=1
1045 mv ${tmpfile}{,.Z} 1286 mv ${tmpfile}{,.Z}
1046 gunzip ${tmpfile} 1287 gunzip ${tmpfile}
1047 else 1288 else
1048 iscompressed=0 1289 iscompressed=0
1049 fi 1290 fi
1050 local istar="`file -b ${tmpfile}`" 1291 local istar=$(file -b "${tmpfile}")
1051 if [ "${istar:0:9}" == "POSIX tar" ] ; then 1292 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1052 istar=1 1293 istar=1
1053 else 1294 else
1054 istar=0 1295 istar=0
1055 fi 1296 fi
1056 1297
1084 true 1325 true
1085 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1326 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1086 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1327 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1087} 1328}
1088 1329
1330# @FUNCTION: unpack_makeself
1331# @USAGE: [file to unpack] [offset] [tail|dd]
1332# @DESCRIPTION:
1089# Unpack those pesky makeself generated files ... 1333# Unpack those pesky makeself generated files ...
1090# They're shell scripts with the binary package tagged onto 1334# They're shell scripts with the binary package tagged onto
1091# the end of the archive. Loki utilized the format as does 1335# the end of the archive. Loki utilized the format as does
1092# many other game companies. 1336# many other game companies.
1093# 1337#
1094# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1338# If the file is not specified, then ${A} is used. If the
1095# - If the file is not specified then unpack will utilize ${A}.
1096# - If the offset is not specified then we will attempt to extract 1339# offset is not specified then we will attempt to extract
1097# the proper offset from the script itself. 1340# the proper offset from the script itself.
1098unpack_makeself() { 1341unpack_makeself() {
1099 local src_input=${1:-${A}} 1342 local src_input=${1:-${A}}
1100 local src=$(find_unpackable_file "${src_input}") 1343 local src=$(find_unpackable_file "${src_input}")
1101 local skip=$2 1344 local skip=$2
1102 local exe=$3 1345 local exe=$3
1104 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1347 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1105 1348
1106 local shrtsrc=$(basename "${src}") 1349 local shrtsrc=$(basename "${src}")
1107 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1350 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1108 if [[ -z ${skip} ]] ; then 1351 if [[ -z ${skip} ]] ; then
1109 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1352 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1110 local skip=0 1353 local skip=0
1111 exe=tail 1354 exe=tail
1112 case ${ver} in 1355 case ${ver} in
1113 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1356 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1114 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1357 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1115 ;; 1358 ;;
1116 2.0|2.0.1) 1359 2.0|2.0.1)
1117 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1360 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1118 ;; 1361 ;;
1119 2.1.1) 1362 2.1.1)
1120 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1363 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1121 let skip="skip + 1" 1364 (( skip++ ))
1122 ;; 1365 ;;
1123 2.1.2) 1366 2.1.2)
1124 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1367 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1125 let skip="skip + 1" 1368 (( skip++ ))
1126 ;; 1369 ;;
1127 2.1.3) 1370 2.1.3)
1128 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1371 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1129 let skip="skip + 1" 1372 (( skip++ ))
1130 ;; 1373 ;;
1131 2.1.4|2.1.5) 1374 2.1.4|2.1.5)
1132 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1375 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1133 skip=$(head -n ${skip} "${src}" | wc -c) 1376 skip=$(head -n ${skip} "${src}" | wc -c)
1134 exe="dd" 1377 exe="dd"
1143 esac 1386 esac
1144 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1387 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1145 fi 1388 fi
1146 case ${exe} in 1389 case ${exe} in
1147 tail) exe="tail -n +${skip} '${src}'";; 1390 tail) exe="tail -n +${skip} '${src}'";;
1148 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1391 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1149 *) die "makeself cant handle exe '${exe}'" 1392 *) die "makeself cant handle exe '${exe}'"
1150 esac 1393 esac
1151 1394
1152 # lets grab the first few bytes of the file to figure out what kind of archive it is 1395 # lets grab the first few bytes of the file to figure out what kind of archive it is
1153 local tmpfile="$(emktemp)" 1396 local tmpfile=$(emktemp)
1154 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1397 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1155 local filetype="$(file -b "${tmpfile}")" 1398 local filetype=$(file -b "${tmpfile}")
1156 case ${filetype} in 1399 case ${filetype} in
1157 *tar\ archive) 1400 *tar\ archive*)
1158 eval ${exe} | tar --no-same-owner -xf - 1401 eval ${exe} | tar --no-same-owner -xf -
1159 ;; 1402 ;;
1160 bzip2*) 1403 bzip2*)
1161 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf - 1404 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1162 ;; 1405 ;;
1172 ;; 1415 ;;
1173 esac 1416 esac
1174 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1417 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1175} 1418}
1176 1419
1420# @FUNCTION: check_license
1421# @USAGE: [license]
1422# @DESCRIPTION:
1177# Display a license for user to accept. 1423# Display a license for user to accept. If no license is
1178#
1179# Usage: check_license [license]
1180# - If the file is not specified then ${LICENSE} is used. 1424# specified, then ${LICENSE} is used.
1181check_license() { 1425check_license() {
1182 local lic=$1 1426 local lic=$1
1183 if [ -z "${lic}" ] ; then 1427 if [ -z "${lic}" ] ; then
1184 lic="${PORTDIR}/licenses/${LICENSE}" 1428 lic="${PORTDIR}/licenses/${LICENSE}"
1185 else 1429 else
1189 lic="${PWD}/${lic}" 1433 lic="${PWD}/${lic}"
1190 elif [ -e "${lic}" ] ; then 1434 elif [ -e "${lic}" ] ; then
1191 lic="${lic}" 1435 lic="${lic}"
1192 fi 1436 fi
1193 fi 1437 fi
1194 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1195 local l="`basename ${lic}`" 1438 local l="`basename ${lic}`"
1196 1439
1197 # here is where we check for the licenses the user already 1440 # here is where we check for the licenses the user already
1198 # accepted ... if we don't find a match, we make the user accept 1441 # accepted ... if we don't find a match, we make the user accept
1199 local shopts=$-
1200 local alic 1442 local alic
1201 set -o noglob #so that bash doesn't expand "*" 1443 eshopts_push -o noglob # so that bash doesn't expand "*"
1202 for alic in ${ACCEPT_LICENSE} ; do 1444 for alic in ${ACCEPT_LICENSE} ; do
1203 if [[ ${alic} == * || ${alic} == ${l} ]]; then 1445 if [[ ${alic} == ${l} ]]; then
1204 set +o noglob; set -${shopts} #reset old shell opts 1446 eshopts_pop
1205 return 0 1447 return 0
1206 fi 1448 fi
1207 done 1449 done
1208 set +o noglob; set -$shopts #reset old shell opts 1450 eshopts_pop
1451 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1209 1452
1210 local licmsg="$(emktemp)" 1453 local licmsg=$(emktemp)
1211 cat << EOF > ${licmsg} 1454 cat <<-EOF > ${licmsg}
1212********************************************************** 1455 **********************************************************
1213The following license outlines the terms of use of this 1456 The following license outlines the terms of use of this
1214package. You MUST accept this license for installation to 1457 package. You MUST accept this license for installation to
1215continue. When you are done viewing, hit 'q'. If you 1458 continue. When you are done viewing, hit 'q'. If you
1216CTRL+C out of this, the install will not run! 1459 CTRL+C out of this, the install will not run!
1217********************************************************** 1460 **********************************************************
1218 1461
1219EOF 1462 EOF
1220 cat ${lic} >> ${licmsg} 1463 cat ${lic} >> ${licmsg}
1221 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1464 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1222 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1465 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1223 read alic 1466 read alic
1224 case ${alic} in 1467 case ${alic} in
1231 die "Failed to accept license" 1474 die "Failed to accept license"
1232 ;; 1475 ;;
1233 esac 1476 esac
1234} 1477}
1235 1478
1479# @FUNCTION: cdrom_get_cds
1480# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1481# @DESCRIPTION:
1236# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1482# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1237# the whole 'non-interactive' policy, but damnit I want CD support ! 1483# the whole 'non-interactive' policy, but damnit I want CD support !
1238# 1484#
1239# with these cdrom functions we handle all the user interaction and 1485# With these cdrom functions we handle all the user interaction and
1240# standardize everything. all you have to do is call cdrom_get_cds() 1486# standardize everything. All you have to do is call cdrom_get_cds()
1241# and when the function returns, you can assume that the cd has been 1487# and when the function returns, you can assume that the cd has been
1242# found at CDROM_ROOT. 1488# found at CDROM_ROOT.
1243# 1489#
1490# The function will attempt to locate a cd based upon a file that is on
1491# the cd. The more files you give this function, the more cds
1492# the cdrom functions will handle.
1493#
1244# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1494# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1245# etc... if you want to give the cds better names, then just export 1495# etc... If you want to give the cds better names, then just export
1246# the CDROM_NAME_X variables before calling cdrom_get_cds(). 1496# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1497# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1498# also use the CDROM_NAME_SET bash array.
1247# 1499#
1248# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1500# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1249#
1250# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1251# - this will attempt to locate a cd based upon a file that is on
1252# the cd ... the more files you give this function, the more cds
1253# the cdrom functions will handle
1254cdrom_get_cds() { 1501cdrom_get_cds() {
1255 # first we figure out how many cds we're dealing with by 1502 # first we figure out how many cds we're dealing with by
1256 # the # of files they gave us 1503 # the # of files they gave us
1257 local cdcnt=0 1504 local cdcnt=0
1258 local f= 1505 local f=
1282 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1529 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1283 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1530 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1284 export CDROM_SET=-1 1531 export CDROM_SET=-1
1285 for f in ${CDROM_CHECK_1//:/ } ; do 1532 for f in ${CDROM_CHECK_1//:/ } ; do
1286 ((++CDROM_SET)) 1533 ((++CDROM_SET))
1287 [[ -e ${CD_ROOT}/${f} ]] && break 1534 [[ -e ${CDROM_ROOT}/${f} ]] && break
1288 done 1535 done
1289 export CDROM_MATCH=${f} 1536 export CDROM_MATCH=${f}
1290 return 1537 return
1291 fi 1538 fi
1292 1539
1302 echo 1549 echo
1303 einfo "For example:" 1550 einfo "For example:"
1304 einfo "export CD_ROOT=/mnt/cdrom" 1551 einfo "export CD_ROOT=/mnt/cdrom"
1305 echo 1552 echo
1306 else 1553 else
1554 if [[ -n ${CDROM_NAME_SET} ]] ; then
1555 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1556 cdcnt=0
1557 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1558 ((++cdcnt))
1559 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1560 done
1561 fi
1562
1307 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1563 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1308 cdcnt=0 1564 cdcnt=0
1309 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1565 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1310 ((++cdcnt)) 1566 ((++cdcnt))
1311 var="CDROM_NAME_${cdcnt}" 1567 var="CDROM_NAME_${cdcnt}"
1335 export CDROM_SET="" 1591 export CDROM_SET=""
1336 export CDROM_CURRENT_CD=0 1592 export CDROM_CURRENT_CD=0
1337 cdrom_load_next_cd 1593 cdrom_load_next_cd
1338} 1594}
1339 1595
1340# this is only used when you need access to more than one cd. 1596# @FUNCTION: cdrom_load_next_cd
1341# when you have finished using the first cd, just call this function. 1597# @DESCRIPTION:
1342# when it returns, CDROM_ROOT will be pointing to the second cd. 1598# Some packages are so big they come on multiple CDs. When you're done reading
1343# remember, you can only go forward in the cd chain, you can't go back. 1599# files off a CD and want access to the next one, just call this function.
1600# Again, all the messy details of user interaction are taken care of for you.
1601# Once this returns, just read the variable CDROM_ROOT for the location of the
1602# mounted CD. Note that you can only go forward in the CD list, so make sure
1603# you only call this function when you're done using the current CD.
1344cdrom_load_next_cd() { 1604cdrom_load_next_cd() {
1345 local var 1605 local var
1346 ((++CDROM_CURRENT_CD)) 1606 ((++CDROM_CURRENT_CD))
1347 1607
1348 unset CDROM_ROOT 1608 unset CDROM_ROOT
1365# displayed and we'll hang out here until: 1625# displayed and we'll hang out here until:
1366# (1) the file is found on a mounted cdrom 1626# (1) the file is found on a mounted cdrom
1367# (2) the user hits CTRL+C 1627# (2) the user hits CTRL+C
1368_cdrom_locate_file_on_cd() { 1628_cdrom_locate_file_on_cd() {
1369 local mline="" 1629 local mline=""
1370 local showedmsg=0 1630 local showedmsg=0 showjolietmsg=0
1371 1631
1372 while [[ -z ${CDROM_ROOT} ]] ; do 1632 while [[ -z ${CDROM_ROOT} ]] ; do
1373 local i=0 1633 local i=0
1374 local -a cdset=(${*//:/ }) 1634 local -a cdset=(${*//:/ })
1375 if [[ -n ${CDROM_SET} ]] ; then 1635 if [[ -n ${CDROM_SET} ]] ; then
1378 1638
1379 while [[ -n ${cdset[${i}]} ]] ; do 1639 while [[ -n ${cdset[${i}]} ]] ; do
1380 local dir=$(dirname ${cdset[${i}]}) 1640 local dir=$(dirname ${cdset[${i}]})
1381 local file=$(basename ${cdset[${i}]}) 1641 local file=$(basename ${cdset[${i}]})
1382 1642
1383 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1643 local point= node= fs= foo=
1644 while read point node fs foo ; do
1645 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1646 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1647 && continue
1648 point=${point//\040/ }
1384 [[ -d ${mline}/${dir} ]] || continue 1649 [[ ! -d ${point}/${dir} ]] && continue
1385 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1650 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1386 export CDROM_ROOT=${mline} 1651 export CDROM_ROOT=${point}
1387 export CDROM_SET=${i} 1652 export CDROM_SET=${i}
1388 export CDROM_MATCH=${cdset[${i}]} 1653 export CDROM_MATCH=${cdset[${i}]}
1389 return 1654 return
1390 fi 1655 done <<< "$(get_mounts)"
1391 done
1392 1656
1393 ((++i)) 1657 ((++i))
1394 done 1658 done
1395 1659
1396 echo 1660 echo
1412 showedmsg=1 1676 showedmsg=1
1413 fi 1677 fi
1414 einfo "Press return to scan for the cd again" 1678 einfo "Press return to scan for the cd again"
1415 einfo "or hit CTRL+C to abort the emerge." 1679 einfo "or hit CTRL+C to abort the emerge."
1416 echo 1680 echo
1681 if [[ ${showjolietmsg} -eq 0 ]] ; then
1682 showjolietmsg=1
1683 else
1417 einfo "If you are having trouble with the detection" 1684 ewarn "If you are having trouble with the detection"
1418 einfo "of your CD, it is possible that you do not have" 1685 ewarn "of your CD, it is possible that you do not have"
1419 einfo "Joliet support enabled in your kernel. Please" 1686 ewarn "Joliet support enabled in your kernel. Please"
1420 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1687 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1688 ebeep 5
1689 fi
1421 read || die "something is screwed with your system" 1690 read || die "something is screwed with your system"
1422 done 1691 done
1423} 1692}
1424 1693
1694# @FUNCTION: strip-linguas
1695# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1696# @DESCRIPTION:
1425# Make sure that LINGUAS only contains languages that 1697# Make sure that LINGUAS only contains languages that
1426# a package can support 1698# a package can support. The first form allows you to
1427# 1699# specify a list of LINGUAS. The -i builds a list of po
1428# usage: strip-linguas <allow LINGUAS> 1700# files found in all the directories and uses the
1429# strip-linguas -i <directories of .po files> 1701# intersection of the lists. The -u builds a list of po
1430# strip-linguas -u <directories of .po files> 1702# files found in all the directories and uses the union
1431# 1703# of the lists.
1432# The first form allows you to specify a list of LINGUAS.
1433# The -i builds a list of po files found in all the
1434# directories and uses the intersection of the lists.
1435# The -u builds a list of po files found in all the
1436# directories and uses the union of the lists.
1437strip-linguas() { 1704strip-linguas() {
1438 local ls newls 1705 local ls newls nols
1439 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1706 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1440 local op=$1; shift 1707 local op=$1; shift
1441 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1708 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1442 local d f 1709 local d f
1443 for d in "$@" ; do 1710 for d in "$@" ; do
1444 if [[ ${op} == "-u" ]] ; then 1711 if [[ ${op} == "-u" ]] ; then
1445 newls=${ls} 1712 newls=${ls}
1446 else 1713 else
1447 newls="" 1714 newls=""
1448 fi 1715 fi
1449 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1716 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1450 if [[ ${op} == "-i" ]] ; then 1717 if [[ ${op} == "-i" ]] ; then
1451 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}" 1718 hasq ${f} ${ls} && newls="${newls} ${f}"
1452 else 1719 else
1453 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}" 1720 hasq ${f} ${ls} || newls="${newls} ${f}"
1454 fi 1721 fi
1455 done 1722 done
1456 ls=${newls} 1723 ls=${newls}
1457 done 1724 done
1458 ls=${ls//.po}
1459 else 1725 else
1460 ls=$@ 1726 ls="$@"
1461 fi 1727 fi
1462 1728
1463 ls=" ${ls} " 1729 nols=""
1464 newls="" 1730 newls=""
1465 for f in ${LINGUAS} ; do 1731 for f in ${LINGUAS} ; do
1466 if [[ ${ls/ ${f} /} != ${ls} ]] ; then 1732 if hasq ${f} ${ls} ; then
1467 newls="${newls} ${f}" 1733 newls="${newls} ${f}"
1468 else 1734 else
1469 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1735 nols="${nols} ${f}"
1470 fi 1736 fi
1471 done 1737 done
1472 if [[ -z ${newls} ]] ; then 1738 [[ -n ${nols} ]] \
1473 export LINGUAS="" 1739 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1474 else
1475 export LINGUAS=${newls:1} 1740 export LINGUAS=${newls:1}
1476 fi
1477} 1741}
1478 1742
1479# moved from kernel.eclass since they are generally useful outside of 1743# @FUNCTION: preserve_old_lib
1480# kernel.eclass -iggy (20041002) 1744# @USAGE: <libs to preserve> [more libs]
1481 1745# @DESCRIPTION:
1482# the following functions are useful in kernel module ebuilds, etc.
1483# for an example see ivtv or drbd ebuilds
1484
1485# set's ARCH to match what the kernel expects
1486set_arch_to_kernel() {
1487 i=10
1488 while ((i--)) ; do
1489 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1490 done
1491 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1492 case ${ARCH} in
1493 x86) export ARCH="i386";;
1494 amd64) export ARCH="x86_64";;
1495 hppa) export ARCH="parisc";;
1496 mips) export ARCH="mips";;
1497 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1498 *) export ARCH="${ARCH}";;
1499 esac
1500}
1501
1502# set's ARCH back to what portage expects
1503set_arch_to_portage() {
1504 i=10
1505 while ((i--)) ; do
1506 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1507 done
1508 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1509}
1510
1511# Jeremy Huddleston <eradicator@gentoo.org>:
1512# preserve_old_lib /path/to/libblah.so.0
1513# preserve_old_lib_notify /path/to/libblah.so.0
1514#
1515# These functions are useful when a lib in your package changes --soname. Such 1746# These functions are useful when a lib in your package changes ABI SONAME.
1516# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1747# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1517# would break packages that link against it. Most people get around this 1748# would break packages that link against it. Most people get around this
1518# by using the portage SLOT mechanism, but that is not always a relevant 1749# by using the portage SLOT mechanism, but that is not always a relevant
1519# solution, so instead you can add the following to your ebuilds: 1750# solution, so instead you can call this from pkg_preinst. See also the
1520# 1751# preserve_old_lib_notify function.
1521# src_install() {
1522# ...
1523# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1524# ...
1525# }
1526#
1527# pkg_postinst() {
1528# ...
1529# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1530# ...
1531# }
1532
1533preserve_old_lib() { 1752preserve_old_lib() {
1534 LIB=$1 1753 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1754 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1755 die "Invalid preserve_old_lib() usage"
1756 fi
1757 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1535 1758
1536 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1759 # let portage worry about it
1537 SONAME=`basename ${LIB}` 1760 has preserve-libs ${FEATURES} && return 0
1538 DIRNAME=`dirname ${LIB}`
1539 1761
1540 dodir ${DIRNAME} 1762 local lib dir
1541 cp ${ROOT}${LIB} ${D}${DIRNAME} 1763 for lib in "$@" ; do
1764 [[ -e ${ROOT}/${lib} ]] || continue
1765 dir=${lib%/*}
1766 dodir ${dir} || die "dodir ${dir} failed"
1767 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1542 touch ${D}${LIB} 1768 touch "${D}"/${lib}
1543 fi 1769 done
1544} 1770}
1545 1771
1772# @FUNCTION: preserve_old_lib_notify
1773# @USAGE: <libs to notify> [more libs]
1774# @DESCRIPTION:
1775# Spit helpful messages about the libraries preserved by preserve_old_lib.
1546preserve_old_lib_notify() { 1776preserve_old_lib_notify() {
1547 LIB=$1 1777 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1778 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1779 die "Invalid preserve_old_lib_notify() usage"
1780 fi
1548 1781
1549 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1782 # let portage worry about it
1550 SONAME=`basename ${LIB}` 1783 has preserve-libs ${FEATURES} && return 0
1551 1784
1785 local lib notice=0
1786 for lib in "$@" ; do
1787 [[ -e ${ROOT}/${lib} ]] || continue
1788 if [[ ${notice} -eq 0 ]] ; then
1789 notice=1
1552 ewarn "An old version of an installed library was detected on your system." 1790 ewarn "Old versions of installed libraries were detected on your system."
1553 ewarn "In order to avoid breaking packages that link against it, this older version" 1791 ewarn "In order to avoid breaking packages that depend on these old libs,"
1554 ewarn "is not being removed. In order to make full use of this newer version," 1792 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1555 ewarn "you will need to execute the following command:" 1793 ewarn "in order to remove these old dependencies. If you do not have this"
1556 ewarn " revdep-rebuild --soname ${SONAME}" 1794 ewarn "helper program, simply emerge the 'gentoolkit' package."
1795 ewarn
1796 fi
1797 ewarn " # revdep-rebuild --library '${lib}'"
1798 done
1799 if [[ ${notice} -eq 1 ]] ; then
1557 ewarn 1800 ewarn
1558 ewarn "After doing that, you can safely remove ${LIB}" 1801 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1559 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1802 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1803 for lib in "$@" ; do
1804 ewarn " # rm '${lib}'"
1805 done
1560 fi 1806 fi
1561} 1807}
1562 1808
1563# Hack for people to figure out if a package was built with 1809# @FUNCTION: built_with_use
1564# certain USE flags 1810# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1811# @DESCRIPTION:
1565# 1812#
1566# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1813# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1567# ex: built_with_use xchat gtk2
1568# 1814#
1569# Flags: -a all USE flags should be utilized 1815# A temporary hack until portage properly supports DEPENDing on USE
1570# -o at least one USE flag should be utilized 1816# flags being enabled in packages. This will check to see if the specified
1571# Note: the default flag is '-a' 1817# DEPEND atom was built with the specified list of USE flags. The
1818# --missing option controls the behavior if called on a package that does
1819# not actually support the defined USE flags (aka listed in IUSE).
1820# The default is to abort (call die). The -a and -o flags control
1821# the requirements of the USE flags. They correspond to "and" and "or"
1822# logic. So the -a flag means all listed USE flags must be enabled
1823# while the -o flag means at least one of the listed IUSE flags must be
1824# enabled. The --hidden option is really for internal use only as it
1825# means the USE flag we're checking is hidden expanded, so it won't be found
1826# in IUSE like normal USE flags.
1827#
1828# Remember that this function isn't terribly intelligent so order of optional
1829# flags matter.
1572built_with_use() { 1830built_with_use() {
1831 local hidden="no"
1832 if [[ $1 == "--hidden" ]] ; then
1833 hidden="yes"
1834 shift
1835 fi
1836
1837 local missing_action="die"
1838 if [[ $1 == "--missing" ]] ; then
1839 missing_action=$2
1840 shift ; shift
1841 case ${missing_action} in
1842 true|false|die) ;;
1843 *) die "unknown action '${missing_action}'";;
1844 esac
1845 fi
1846
1573 local opt=$1 1847 local opt=$1
1574 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1848 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1575 1849
1576 local PKG=$(best_version $1) 1850 local PKG=$(best_version $1)
1851 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1577 shift 1852 shift
1578 1853
1579 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1854 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1855 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1580 1856
1581 # if the USE file doesnt exist, assume the $PKG is either 1857 # if the IUSE file doesn't exist, the read will error out, we need to handle
1582 # injected or package.provided 1858 # this gracefully
1583 [[ ! -e ${USEFILE} ]] && return 0 1859 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1860 case ${missing_action} in
1861 true) return 0;;
1862 false) return 1;;
1863 die) die "Unable to determine what USE flags $PKG was built with";;
1864 esac
1865 fi
1866
1867 if [[ ${hidden} == "no" ]] ; then
1868 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1869 # Don't check USE_EXPAND #147237
1870 local expand
1871 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1872 if [[ $1 == ${expand}_* ]] ; then
1873 expand=""
1874 break
1875 fi
1876 done
1877 if [[ -n ${expand} ]] ; then
1878 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1879 case ${missing_action} in
1880 true) return 0;;
1881 false) return 1;;
1882 die) die "$PKG does not actually support the $1 USE flag!";;
1883 esac
1884 fi
1885 fi
1886 fi
1584 1887
1585 local USE_BUILT=$(<${USEFILE}) 1888 local USE_BUILT=$(<${USEFILE})
1586 while [[ $# -gt 0 ]] ; do 1889 while [[ $# -gt 0 ]] ; do
1587 if [[ ${opt} = "-o" ]] ; then 1890 if [[ ${opt} = "-o" ]] ; then
1588 has $1 ${USE_BUILT} && return 0 1891 has $1 ${USE_BUILT} && return 0
1592 shift 1895 shift
1593 done 1896 done
1594 [[ ${opt} = "-a" ]] 1897 [[ ${opt} = "-a" ]]
1595} 1898}
1596 1899
1900# @FUNCTION: epunt_cxx
1901# @USAGE: [dir to scan]
1902# @DESCRIPTION:
1597# Many configure scripts wrongly bail when a C++ compiler 1903# Many configure scripts wrongly bail when a C++ compiler could not be
1598# could not be detected. #73450 1904# detected. If dir is not specified, then it defaults to ${S}.
1905#
1906# http://bugs.gentoo.org/73450
1599epunt_cxx() { 1907epunt_cxx() {
1600 local dir=$1 1908 local dir=$1
1601 [[ -z ${dir} ]] && dir=${S} 1909 [[ -z ${dir} ]] && dir=${S}
1602 ebegin "Removing useless C++ checks" 1910 ebegin "Removing useless C++ checks"
1603 local f 1911 local f
1604 for f in $(find ${dir} -name configure) ; do 1912 find "${dir}" -name configure | while read f ; do
1605 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1913 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1606 done 1914 done
1607 eend 0 1915 eend 0
1608} 1916}
1609 1917
1610# dopamd <file> [more files] 1918# @FUNCTION: make_wrapper
1611# 1919# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1612# Install pam auth config file in /etc/pam.d 1920# @DESCRIPTION:
1613dopamd() { 1921# Create a shell wrapper script named wrapper in installpath
1614 [[ -z $1 ]] && die "dopamd requires at least one argument" 1922# (defaults to the bindir) to execute target (default of wrapper) by
1615 1923# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1616 use pam || return 0 1924# libpaths followed by optionally changing directory to chdir.
1617
1618 INSDESTTREE=/etc/pam.d \
1619 doins "$@" || die "failed to install $@"
1620}
1621# newpamd <old name> <new name>
1622#
1623# Install pam file <old name> as <new name> in /etc/pam.d
1624newpamd() {
1625 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1626
1627 use pam || return 0
1628
1629 INSDESTTREE=/etc/pam.d \
1630 newins "$1" "$2" || die "failed to install $1 as $2"
1631}
1632
1633# make a wrapper script ...
1634# NOTE: this was originally games_make_wrapper, but I noticed other places where
1635# this could be used, so I have moved it here and made it not games-specific
1636# -- wolf31o2
1637# $1 == wrapper name
1638# $2 == binary to run
1639# $3 == directory to chdir before running binary
1640# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1641# $5 == path for wrapper
1642make_wrapper() { 1925make_wrapper() {
1643 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1926 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1644 local tmpwrapper=$(emktemp) 1927 local tmpwrapper=$(emktemp)
1645 # We don't want to quote ${bin} so that people can pass complex 1928 # We don't want to quote ${bin} so that people can pass complex
1646 # things as $bin ... "./someprog --args" 1929 # things as $bin ... "./someprog --args"
1656fi 1939fi
1657exec ${bin} "\$@" 1940exec ${bin} "\$@"
1658EOF 1941EOF
1659 chmod go+rx "${tmpwrapper}" 1942 chmod go+rx "${tmpwrapper}"
1660 if [[ -n ${path} ]] ; then 1943 if [[ -n ${path} ]] ; then
1944 (
1661 exeinto "${path}" 1945 exeinto "${path}"
1662 newexe "${tmpwrapper}" "${wrapper}" 1946 newexe "${tmpwrapper}" "${wrapper}"
1947 ) || die
1663 else 1948 else
1664 newbin "${tmpwrapper}" "${wrapper}" 1949 newbin "${tmpwrapper}" "${wrapper}" || die
1950 fi
1951}
1952
1953# @FUNCTION: prepalldocs
1954# @USAGE:
1955# @DESCRIPTION:
1956# Compress files in /usr/share/doc which are not already
1957# compressed, excluding /usr/share/doc/${PF}/html.
1958# Uses the ecompressdir to do the compression.
1959# 2009-02-18 by betelgeuse:
1960# Commented because ecompressdir is even more internal to
1961# Portage than prepalldocs (it's not even mentioned in man 5
1962# ebuild). Please submit a better version for review to gentoo-dev
1963# if you want prepalldocs here.
1964#prepalldocs() {
1965# if [[ -n $1 ]] ; then
1966# ewarn "prepalldocs: invalid usage; takes no arguments"
1665 fi 1967# fi
1968
1969# cd "${D}"
1970# [[ -d usr/share/doc ]] || return 0
1971
1972# find usr/share/doc -exec gzip {} +
1973# ecompressdir --ignore /usr/share/doc/${PF}/html
1974# ecompressdir --queue /usr/share/doc
1975#}
1976
1977# @FUNCTION: path_exists
1978# @USAGE: [-a|-o] <paths>
1979# @DESCRIPTION:
1980# Check if the specified paths exist. Works for all types of paths
1981# (files/dirs/etc...). The -a and -o flags control the requirements
1982# of the paths. They correspond to "and" and "or" logic. So the -a
1983# flag means all the paths must exist while the -o flag means at least
1984# one of the paths must exist. The default behavior is "and". If no
1985# paths are specified, then the return value is "false".
1986path_exists() {
1987 local opt=$1
1988 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1989
1990 # no paths -> return false
1991 # same behavior as: [[ -e "" ]]
1992 [[ $# -eq 0 ]] && return 1
1993
1994 local p r=0
1995 for p in "$@" ; do
1996 [[ -e ${p} ]]
1997 : $(( r += $? ))
1998 done
1999
2000 case ${opt} in
2001 -a) return $(( r != 0 )) ;;
2002 -o) return $(( r == $# )) ;;
2003 esac
1666} 2004}

Legend:
Removed from v.1.225  
changed lines
  Added in v.1.353

  ViewVC Help
Powered by ViewVC 1.1.20